For AI agents: a documentation index is available at /llms.txt. A markdown version of this page is available at the same URL with .md appended (or via Accept: text/markdown).
Skip to main content

eth_getUserOperationByHash

Fetches user operation details by providing its hash. If the user operation is not available, it will return null. This method uses 100 credits from your daily balance.

Parameters​

  • userOpHash: (string) - The 32-byte hash of the user operation to retrieve.

Returns​

An object containing the user operation information and transaction details, or null if the user operation is not available. When available, the response object contains:

  • userOperation: (object) - The user operation object containing:
    • sender: (string) - The address of the account that initiated the user operation.
    • nonce: (string) - The nonce used for the user operation.
    • initCode: (string) - The initialization code for account creation.
    • callData: (string) - The data to pass to the sender during the main execution call.
    • callGasLimit: (string) - The amount of gas allocated for the main execution call.
    • verificationGasLimit: (string) - The amount of gas allocated for the verification step.
    • preVerificationGas: (string) - The amount of gas to compensate the bundler for pre-verification execution.
    • maxFeePerGas: (string) - Maximum fee per gas, in wei, the sender is willing to pay per gas.
    • maxPriorityFeePerGas: (string) - Maximum fee, in wei, the sender is willing to pay per gas above the base fee.
    • paymasterAndData: (string) - The paymaster address and data.
    • signature: (string) - The signature data for the user operation.
  • entryPoint: (string) - The EntryPoint contract address used.
  • transactionHash: (string) - The hash of the transaction that included this user operation.
  • blockHash: (string) - The hash of the block containing the transaction.
  • blockNumber: (string) - The number of the block containing the transaction.

Example​

Replace <YOUR-API-KEY> with an API key from your Infura dashboard.

Request​

curl https://mainnet.infura.io/v3/<YOUR-API-KEY> \
-X POST \
-H "Content-Type: application/json" \
-d '{
"jsonrpc": "2.0",
"method": "eth_getUserOperationByHash",
"params": ["0xa5a579c6fd86c2d8a4d27f5bb22796614d3a31bbccaba8f3019ec001e001b95f"],
"id": 1
}'

Response​

{
"jsonrpc": "2.0",
"id": 1,
"result": {
"userOperation": {
"sender": "0x8C6bdb488F664EB98E12cB2671fE2389Cc227D33",
"nonce": "0x18554d9a95404c5e8ac591f8608a18f80000000000000000",
"initCode": "0xaee9762ce625e0a8f7b184670fb57c37bfe1d0f1296601cd000000000000000000000000417f5a41305ddc99d18b5e176521b468b2a31b86000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000014c982ab3499d854fca39ff8326b27d3b8a9463c5d000000000000000000000000",
"callData": "0x519454470000000000000000000000008eb187a55b701f8990539bf219b7921d5d3bdadd00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000080000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000001647c7efe6b0000000000000000000000000000000000000000000000000000000000000080bfa0715290784075e564f966fffd9898ace1d7814f833780f62e59b0791357460000000000000000000000008c6bdb488f664eb98e12cb2671fe2389cc227d3300000000000000000000000000000000000000000000000000000000000000c00000000000000000000000000000000000000000000000000000000000000007677265676f7279000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000080000000000000000000000000000000000000000000000000000000000000001b1ec8da9a52488e3f60b7b7af36c2e64f1873e03a047c2c2e9061bbef4d0a9d8f1332b32afb163075273cd462140c2a24b2c9e1276adfaae0b4cb84ef78b95e8a0000000000000000000000000000000000000000000000000000000065a32e4f00000000000000000000000000000000000000000000000000000000",
"callGasLimit": "0x39b2d",
"verificationGasLimit": "0x6fb14",
"preVerificationGas": "0xc6a0",
"maxFeePerGas": "0x974038caf",
"maxPriorityFeePerGas": "0x974038c95",
"paymasterAndData": "0xe3dc822d77f8ca7ac74c30b0dffea9fcdcaaa3210000000000000000000000000000000000000000000000000000000065a3229b00000000000000000000000000000000000000000000000000000000000000009c3e8f934f2ec99974fddae7d38107a6d899c236c1b127e97d3c074cea5bb328023e295bb95254be40c47b82633676f8716c43c81aca3f2e49c2944afd1326371b",
"signature": "0x000000003ea0a3434dfd35a9eb05c4605466a7e05a5c3fc8aaba066c83bf4b43300dfd930e2203725eafa2702f860e5b6c18b4402ffb86b0d9b9c1719f1692254039810b1b"
},
"entryPoint": "0x5FF137D4b0FDCD49DcA30c7CF57E578a026d2789",
"transactionHash": "0x57465d20d634421008a167cfcfcde94847dba9d6b5d3652b071d4b84e5ce74ff",
"blockHash": "0xeaeec1eff4095bdcae44d86574cf1bf08b14b26be571b7c2290f32f9f250c103",
"blockNumber": "0x31de70e"
}
}